﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace david1
{
    class MyFunc
    {


        /*
        * Main Function
        * Start
        * */

        public static popID UpdatePop(int[] desc, int[] pop, int[] ID, int N, double alpha, double V, int counter, double e, double reloc, double[] zetaVec)
        {

            /*int[] popTmp = pop;
            int[] IDTmp = ID;
            int[] descTmp = desc;
            /* Find next generation */
            double tmpPf;
            double tmpPm;
            double rs;
            double rv;




            /* Step 1 
             * Copy population vector and apply eliminations
             * */


            int[] preElimPop = new int[pop.Length];
            Array.Copy(pop, preElimPop, pop.Length);

            int[] preElimID = new int[ID.Length];
            Array.Copy(ID, preElimID, ID.Length);

            int[] preElimDesc = new int[desc.Length];
            Array.Copy(desc, preElimDesc, desc.Length);


            for (int i = 0; i < N; i++)
            {
                double rnd = GetRandom();
                if (rnd < e)
                {
                    pop[i] = 0;
                    ID[i] = 0;
                    desc[i] = 0;
                }
            }



            /*  Step 2
             *  For every unoccupied site, test for sexual/clonal reproduction with respect to pop. before elimination
             *  */



            for (int i = 0; i < N; i++)
            {
                if (pop[i] == 0) /* Check if site is unoccupied */
                {
                    tmpPf = PFM2(N, preElimPop, i, alpha, 2);
                    tmpPm = PFM2(N, preElimPop, i, alpha, 1);
                    rs = GetRS(tmpPf, tmpPm);
                    rv = GetRV(V, tmpPf, tmpPm);


                    double rnd = GetRandom();


                    if (rs + rv > 1)
                    {

                        double norm = rs + rv;
                        rs = rs / norm;
                        rv = rv / norm;
                    }

                    if (rnd < rs)
                    {
                        counter += 1;
                        ID[i] = counter;
                        desc[i] = 2; /* Sexual descendant */

                        double rnd2 = GetRandom();

                        if ((rnd2 - 0.5) > 0)
                        { pop[i] = 1; }
                        else
                        { pop[i] = 2; }
                    }
                    else if (rnd < rs + rv)
                    {

                        desc[i] = 1; /* Clonal descendant */

                        int parentID = ChooseParentID(preElimID, counter, i, alpha, N);

                        bool sexDetermined = false;
                        int ctr = 0;
                        while (!sexDetermined)
                        {
                            if (parentID == preElimID[ctr])
                            {
                                sexDetermined = true;
                                pop[i] = preElimPop[ctr];
                            }
                            ctr += 1;
                        }
                        ID[i] = parentID;
                    }
                }


            }


            /* Step 3
            * Apply relocations to the whole population
             * */


            for (int i = 0; i < N; i++)
            {

                double rnd = GetRandom();
                if (rnd < reloc)
                {

                    bool condFulfilled = false;

                    /* Check if individual is young/old and determine if we have seeds or not. */
                    if (pop[i] != 0)
                    {
                        if (ID[i] == preElimID[i])
                        {
                            /*If this is true we have an old individual and we need to perform competition */

                            tmpPf = PFM2(N, preElimPop, i, alpha, 2);
                            tmpPm = PFM2(N, preElimPop, i, alpha, 1);
                            rs = GetRS(tmpPf, tmpPm);
                            rv = GetRV(V, tmpPf, tmpPm);

                            double rnd2 = GetRandom();

                            if (rs + rv > 1)
                            {
                                double norm = rs + rv;
                                rs = rs / norm;
                                rv = rv / norm;
                            }

                            if (rnd2 < rs)
                            {
                                condFulfilled = true;
                            }
                        }
                        /* 
                         * If the previous condition is not true and the patch is not empty, we have a young individual. 
                         * If this individual is the consequence of sexual reproduction, perform relocation.
                         */
                        else if (desc[i] == 2)
                        {
                            condFulfilled = true;
                            pop[i] = 0;
                            ID[i] = 0;
                            desc[i] = 0;
                        }
                    }

                    if (condFulfilled)
                    {
                        counter += 1;
                        
                        int stepsToMove = GetPowerNumber(zetaVec, N);
                        int chosenSite;
                        /* Determine if the relocation is to the right or left*/
                        double r = GetRandom();

                        if (r < 0.5)
                        {
                            stepsToMove = stepsToMove * -1;
                            chosenSite = (i - stepsToMove) % N;
                            if (chosenSite < 0) { chosenSite = N + chosenSite; }
                        }
                        else
                        {
                            chosenSite = (i + stepsToMove) % N;
                        }

                        if (pop[chosenSite] == 0)
                        {
                            double tmpRnd = GetRandom();
                            if (tmpRnd < 0.5) { pop[chosenSite] = 1; }
                            else { pop[chosenSite] = 2; }
                            
                            ID[chosenSite] = counter;
                            desc[chosenSite] = 2;
                        }

                    }
                }
            }


            popID outStruct = new popID(desc, pop, ID, counter);
            return outStruct;
        }

        /*
         * Main Function
         * End
         * */


        public static Random rand = new Random();
        public static double GetRandom()
        {
            double rand1 = rand.NextDouble();
            return rand1;
        }

        public static int Distance(int N, int i, int j)
        {
            int tmp = j;
            if (i > j) { j = i; i = tmp; }

            int D1 = Math.Abs(j - i);
            int D2 = Math.Abs(i - j + N);

            if (D1 > D2) { return D2; }
            else { return D1; }
        }


        public static double K(double alpha, int d)
        {
            double tmp = -(double)d * (double)d / (alpha * alpha);
            double outputVal = 1 / (alpha * Math.Sqrt(Math.PI)) * Math.Exp(tmp);

            return outputVal;
        }

        public static double PFM2(int N, int[] pop, int i, double alpha, int maleOrFemale)
        {
            int dmin = 300;
            double outVal = 0d;

            for (int d = -dmin; d < dmin; d++)
            {
                /* Find the position, j, d distance units away from i */

                int j = i + d;
                if (j < 0) { j += N; }
                if (j > N - 1) { j -= N; }

                if (pop[j] == maleOrFemale)
                {
                    outVal += K(alpha, Math.Abs(d));
                }

            }
            return outVal;
        }

        public static double PFM(int N, int[] pop, int i, double alpha, int maleOrFemale)
        {
            double outVal = 0d;

            for (int j = 0; j < N; j++)
            {
                if (pop[j] == maleOrFemale)
                {
                    int d = Distance(N, i, j);
                    outVal += K(alpha, d);
                }
            }
            return outVal;
        }

        public struct popID
        {
            public int[] pop, ID, desc;
            public int counter;

            public popID(int[] descTmp, int[] popVec, int[] IDvec, int counterTmp)
            {
                pop = popVec;
                ID = IDvec;
                desc = descTmp;
                counter = counterTmp;
            }
        }

        public struct IDcounter
        {
            public int[] ID;
            public int counter;

            public IDcounter(int[] IDvec, int counterTmp)
            {
                ID = IDvec;
                counter = counterTmp;
            }

        }

        public static double GetRS(double tmpPf, double tmpPm)
        {
            if (tmpPf < tmpPm) { return 2 * tmpPf; }
            else { return 2 * tmpPm; }
        }

        public static double GetRV(double V, double tmpPf, double tmpPm)
        {
            return V * (tmpPm + tmpPf);
        }

        public static IDcounter InitializeID(int[] pop, int N)
        {
            int counter = 0;
            int[] ID = new int[N];

            for (int i = 0; i < N; i++)
            {
                if (pop[i] != 0)
                {
                    counter += 1;
                    ID[i] = counter;
                }
            }

            IDcounter outStruct = new IDcounter(ID, counter);
            return outStruct;

        }

        public static int ChooseParentID(int[] ID, int counter, int i, double alpha, int N)
        {
            double[] probs = new double[counter];
            double probsum = 0;

            for (int j = 0; j < N; j++)
            {
                if (ID[j] != 0)
                {
                    int d = Distance(N, i, j);
                    double tmp = K(alpha, d);
                    probs[ID[j] - 1] += tmp;
                    probsum += tmp;
                }
            }

            for (int j = 0; j < counter; j++)
            {
                probs[j] = probs[j] / probsum;
            }

            double rand1 = GetRandom();
            bool keepGoing = true;
            double sumOfProbs = 0;
            int ctr = 0;

            while (keepGoing && ctr < counter)
            {

                sumOfProbs += probs[ctr];
                ctr += 1;

                if (rand1 < sumOfProbs)
                {
                    keepGoing = false;
                }

            }

            return ctr;
        }

        public static int GetRelocation(int i, int N)
        {
            return i;
        }


        public static int GetPowerNumber(double[] zetaVec, int N)
        {
            int xmin = 1;
            int M = zetaVec.Length;

            int counter = 0;
            double r = GetRandom();
            int x2 = xmin;
            int x1 = x2;
            bool breakLoop = false;

            while (!breakLoop)
            {
                x1 = x2;
                x2 = 2 * x1;
                counter = counter + 1;


                if (x2 > M)
                {
                    double rand = GetRandom();
                    rand = rand * (double)N;
                    return (int)rand;

                }
                else if (zetaVec[x2 - 1] / zetaVec[xmin - 1] < 1 - r)
                {
                    breakLoop = true;
                }
            }

            int a = x1;
            int b = x2;

            int xDiff = b - a;
            int midx;


            while (xDiff > 1)
            {
                midx = (b - a) / 2 + a;
                if (zetaVec[midx - 1] / zetaVec[xmin - 1] < 1 - r)
                {
                    b = midx;
                }
                else
                {
                    a = midx;
                }
                xDiff = b - a;
            }


            return a;
        }



    }
}
