﻿using System;
using System.Collections.Generic;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace david1
{


    class David
    {


        static void Main(string[] args)
        {

            CultureInfo ci = new CultureInfo("en-US", true);

            double alpha = 3;
            double V = 2E-1;

            int N = 2000; /*Even number or fail */
            double e = 1E-2;
            double reloc = 1E-2;
            int printStep = 50;
            /*string outPath = "F:/SimulationData/Algorithm2/100k/100k_3.txt";*/

            string path = "C:/Dropbox/Masters Thesis/David Kleinhaus Model/Zeta.dat";

            double[] zetaVec = File.ReadAllLines(path).Select(s => double.Parse(s, CultureInfo.InvariantCulture)).ToArray();

            int nbrInhab = 50;
            int nbrRuns = 20;

            for (int run = 1; run < nbrRuns + 1; run++)
            {
                int nbrOfGen = 80000;

                int[] pop = new int[N];
                int[] desc = new int[N];
                int[] ID = new int[N];
                

                string ext1 = V.ToString();
                string ext2 = alpha.ToString();
                string ext3 = e.ToString();
                string ext4 = run.ToString();
                string ext5 = printStep.ToString();
                string ext6 = reloc.ToString();


                string outPath = "C:/Dropbox/Masters Thesis/Relocation of seeds/Data/2k_alpha" + ext2 + "V" + ext1 + "e" + ext3 + "ps" + ext5 + "r" + ext6 + "_" + ext4 + ".txt";

                for (int i = N / 2 - nbrInhab; i < N / 2 + nbrInhab; i++)
                {
                    if (i % 2 == 0) { pop[i] = 1; }
                    else { pop[i] = 2; }
                }


                /* 
                 * This vector has zero if the patch is empty/is occupied by initial individual
                 * 1 if individual descends from clonal reproduction
                 * 2 if indivudual descends from sexual reproduction
                */


                MyFunc.IDcounter IDstr = MyFunc.InitializeID(pop, N);
                ID = IDstr.ID;
                int counter = IDstr.counter;
                int totalOcc = 0;
                int nbrSexuals = 0;
                int nbrClonals = 0;
                /* Print population every printStep generation */
                

                /* Main loop */
                using (var myFile = new StreamWriter(outPath))
                {

                    for (int gen = 0; gen < nbrOfGen; gen++)
                    {
                        MyFunc.popID newPopulation = MyFunc.UpdatePop(desc, pop, ID, N, alpha, V, counter, e, reloc, zetaVec);

                        desc = newPopulation.desc;
                        pop = newPopulation.pop;
                        ID = newPopulation.ID;
                        counter = newPopulation.counter;




                        if (gen % printStep == 0 || gen == 0)
                        {
                            totalOcc = 0;
                            nbrClonals = 0;
                            nbrSexuals = 0;

                            for (int i = 0; i < N; i++)
                            {
                                myFile.Write(ID[i] + ";");
                            }

                            for (int i = 0; i < N; i++)
                            {
                                if (pop[i] != 0) { totalOcc += 1; }
                                if (desc[i] == 1) { nbrClonals += 1; }
                                else if (desc[i] == 2) { nbrSexuals += 1; }

                                myFile.Write(pop[i] + ";");
                            }
                            myFile.WriteLine(totalOcc + ";" + nbrSexuals + ";" + nbrClonals);
                        }

                       


                        if (nbrOfGen / 100 != 0)
                        {
                            if (gen % (nbrOfGen / 100) == 0)
                            {
                                double tmp = (double)gen / (double)nbrOfGen * 100d;
                                Console.WriteLine("{0}%", tmp);
                            }
                        }

                    }

                }
            }
            Console.WriteLine("Finnished");
            Console.ReadKey();
        }
    }
}
